# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# QnD_Mailer            2018 by Doc Holiday
# Version: 1.1
# a Part of the QnD Quest and Dialog System
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# usage:
#	String Property: MailTo (Object that shows the Dialog)
#
#	Message Sensor_______Python Controller
#	Subj: QnD_Mail       QnD_Mailer.py
#
#	optional String Property "MailTo" with QnD Target Object
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
""" A List of all in Value used Properties
	are stored in bge.QnD_Global["UsedProps"]"""
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

import bge, QnD_DataBase as DB
from random import choice

Cont = bge.logic.getCurrentController()
Own = Cont.owner
Mail = Cont.sensors[0]

if "CurrTar" not in Own:
	Own["CurrTar"] = None
	Own["Next"] = 0
	Own["IsCancel"] = Own["IsTalking"] = False
	Own["LastFlag"] = Own["LastVal"] = "◦" # LeerCode für StringAddz
	
	if not Own.get("MailTo"):	# Property für Empfänger, leer für alle
		Own["MailTo"] = ""

GloDic = bge.logic.globalDict
if "QnD" not in GloDic:
	GloDic["QnD"] = {}
QnDDic = GloDic["QnD"]

# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦

def Oops(T):
	print("\n=== QnD Oops %s\n%s\n%s\n" % ("="*30,T,"="*43))

def RestartToNext():
	s = "QnD_Mail"
	b = "Next:"
	t = Own.name
	
	bge.logic.sendMessage(s,b,t)

def SearchSceObj(n):
	return [s for s in bge.logic.getSceneList() if n in s.objects][0].objects[n]

def IdentV(iv):
	if "'" in iv or '"' in iv: return ""
	elif "True" in iv or "False" in iv: return False
	elif "." in iv: return 0.0
	else: return 0

def GetVar(N):
	Mode = N[2]
	
	if Mode == "Rand":
		Var = choice(N[1])
		
	elif Mode == "State":
		Var = QnDDic[TarN][SteN]
	
	elif Mode == "Glob":
		Var = GloDic.get(N[3])
		
	elif Mode == "Sub":
		Var = GloDic.get(N[3])
		if Var:
			Var = Var.get(N[4])
	
	else:	#Mode == "Obj":
		POb = SearchSceObj(N[3])
		Var = POb.get(N[4])

	if Var == None:
		if N[0][0] == "QnD_Level": return 0
		Var = IdentV(N[-1])
	return Var

def ClearAddz(N,s):
	if s.__class__.__name__=="str" and ("($Flag)" in s or "($Val)" in s):
		if "($Flag)" in s and Own["LastFlag"] == "◦": Oops("($Flag) still empty in: %s" % N[0][1])
		if "($Val)" in s and Own["LastVal"] == "◦": Oops("($Val) still empty in: %s" % N[0][1])
		
		lf = (str(Own["LastFlag"]),"%s" % Own["LastFlag"])[Own["LastFlag"].__class__.__name__ == "str"]
		lv = (str(Own["LastVal"]),"%s" % Own["LastVal"])[Own["LastVal"].__class__.__name__ == "str"]
			
		s = s.replace("($Flag)",lf).replace("($Val)",lv)
		
		#print(Own["LastFlag"],Own["LastVal"],lf, lv)
	
	return s

# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦
# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦
# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦

def Work(N,xtra=None):
	Ty = N[0][0]
	
	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> LEVEL <<<
	if Ty == "QnD_Level":
		PVar = int(GetVar(N))
		if N[2] == "Rand":
			Rlt = PVar
		else:
			il = N[1].__len__()
			if N[-1] == True:				# Repeat aktiv
				PVar -= int(PVar/il)*il
			else:
				PVar = max(min(PVar, il-1), 0)		# Clamp PVar

			Rlt = N[1][PVar]

		if xtra:
			return Rlt	# Anfrage kommt aus Player Link IN -> ABBRUCH HIER
		
		Own["Next"] = Rlt
		return True
	
	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> NPC <<<
	elif Ty == "QnD_NPC":
		tx = ClearAddz(N,N[2])
		
		s = "QnD_Display"
		b = "ToNPC|%s|%s|%s" % (tx,N[3],N[4])
		t = Own["MailTo"]
	
		Own["Next"] = N[1][0]
		bge.logic.sendMessage(s,b,t)
	
	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> FLAG <<<
	elif Ty == "QnD_Flag":
		Mode = N[2]
		PVar = GetVar(N) # aktueller Wert zum Vergleich
		
		if PVar.__class__.__name__ == "str": PVar = "'%s'" % PVar
		
		Exp = ClearAddz(N,N[-1])
		
		if Exp == "": Oops("Empty Exp in '%s'"% N[0][1])
		
		if Exp[0] == "=" and Exp[1] != "=": Exp = "="+Exp
		
		Exp = "%s %s" % (PVar,Exp)
		
		Rlt = eval(Exp)
		
		#print(Exp,Rlt)
		
		if xtra:
			return Rlt	# Anfrage kommt aus Player Link IN -> ABBRUCH HIER
	
		Own["LastFlag"] = None	# erst None setzen um evtl. Typ zu wechseln
		Own["LastFlag"] = PVar
		Own["Next"] = N[1][::-1][Rlt]
		
		return True
	
	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> VALUE <<<
	elif Ty == "QnD_Value":
		
		Mode = N[2]
		V = N[-1]
		if V.__class__.__name__ == "str":
			V = V.strip()
			V = ClearAddz(N,V)

		if V == "": Oops("Empty Exp in '%s'"% N[0][1])

		if Mode == "State":
			QnDDic[TarN][SteN] = V
			
			Own["LastVal"] = None
			Own["LastVal"] = V
		
		elif Mode == "Glob":
			if not N[3] in GloDic: GloDic[N[3]] = IdentV(V)
			
			v = ("= GloDic['%s']" % N[3], "")[V[0]=="="]	# bei = nur ""
			
			Exp = "GloDic['%s'] %s %s" % (N[3],v,V)
			exec(Exp)
			
			Own["LastVal"] = None
			Own["LastVal"] = GloDic[N[3]]
		
		elif Mode == "Sub":
			if N[3] not in GloDic or N[4] not in GloDic[N[3]]:
				GloDic[N[3]] = {N[4]:IdentV(V)}
			
			v = ("= GloDic['%s']['%s']" % (N[3],N[4]), "")[V[0]=="="] # bei = nur ""

			Exp = ("GloDic['%s']['%s'] %s %s" % (N[3],N[4],v,V))
			exec(Exp)
			
			Own["LastVal"] = None
			Own["LastVal"] = GloDic[N[3]][N[4]]
			
		elif Mode == "Obj":
			POb = SearchSceObj(N[3])

			if not N[4] in POb:
				Oops("No Property '%s' in Object '%s'\nNode: '%s'"% (N[4],POb.name,N[0][1]))
				POb[N[4]] = IdentV(V)
			
			v = ("= POb['%s']" % N[4], "")[V[0]=="="] # bei = nur ""
			
			Exp = "POb['%s'] %s %s" % (N[4],v,V)
			exec(Exp)
			
			Own["LastVal"] = None
			Own["LastVal"] = POb[N[4]]
			
			gloPro = (POb,N[4])
			if gloPro not in bge.QnD_Global["UsedProps"]:
				bge.QnD_Global["UsedProps"].append(gloPro) # speichere Property in QnD_Global
				#print(bge.QnD_Global["UsedProps"])
		
		Own["Next"] = N[1][0]
		return True

	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> PLAYER <<<
	elif Ty == "QnD_Player":
		ResL = N[1]
		ResW = N[2]
		
		while "__LinkIN__" in ResW:
			lnPos = ResW.index("__LinkIN__")
			FlagN = Tree[ResL[lnPos]]		# Node an Player LinkIN
			
			if FlagN[0][0] == "QnD_Flag":
				FlagR = Work(FlagN,1)			# True/False von Flag Node abfragen	
				OutP = FlagN[1][::-1][FlagR]	# auslesen wo der Output hin geht
				
				if OutP == "*":					# Flag ist False -> nichts anzeigen
					ResW = ResW[:lnPos]+ResW[lnPos+1:]
					ResL = ResL[:lnPos]+ResL[lnPos+1:]
					continue
			
			elif FlagN[0][0] == "QnD_Level":
				OutP = Work(FlagN,1)
			
			else:
				Oops("Flag or Level Node required on Link IN.\nNode: '%s'" % N[0][1])
				break
			
			# ~~~~~~~~
			LnkN = Tree[OutP]				# Player Node an LinkIN Flag
			
			if LnkN[0][0] != "QnD_Player":
				Oops("Final Player Node required on Link IN\nNode: '%s'" % FlagN[0][1])
				break
			
			lnL = LnkN[1]
			lnW = LnkN[2]
			
			ResW = ResW[:lnPos]+LnkN[2]+ResW[lnPos+1:]
			ResL = ResL[:lnPos]+LnkN[1]+ResL[lnPos+1:]
			
		if ResL != ():	# Antwortliste nicht leer
		
			Own["CurrDlnk"] = ResL	# Link Liste für Player Select Antwort
		
			b = "ToPly|"+"|".join(ResW)
			b = ClearAddz(N,b)
			
			s = "QnD_Display"
			t = Own["MailTo"]
			bge.logic.sendMessage(s,b,t)
		
		else:
			Work((("QnD_End",),-1))

	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> XTREE <<<
	elif Ty == "QnD_XTree":

		if not hasattr(DB, N[2]):
			Oops("Tree not in Database: '%s'" % N2)
		else:
			nxTr = getattr(DB, N[2])
			nxSt = "%s_State" % N[2]
		
			Own["CurrTar"]["QnD"] = N[2]
			ens = N[1]
			if ens <0: ens = 0
			
			i = [n for n in nxTr if n[0][0] == "QnD_Start"][0]
			Own["Next"] = i[1][0]
				
			if not nxSt in QnDDic[TarN]:
				QnDDic[TarN][nxSt] = 0
			
			if N[1] >= 0: QnDDic[TarN][nxSt] = ens

			return True


	# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ >>> END <<<
	elif Ty == "QnD_End":
		
		Own["IsCancel"] = Own["IsTalking"] = False
		
		if N[1] >= 0: QnDDic[TarN][SteN] = N[1]
		
		s = "QnD_Display"
		b = "End|%i|%i" % (id(Own["CurrSpk"]),N[1])
		t = Own["MailTo"]
		
		bge.logic.sendMessage(s,b,t)		
			

# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦
# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦
# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦

if Mail.positive:
	
	#print(Mail.bodies)
	
	for Imp in ("Cancel:","Select:", "Next:", "Start:"):
		
		MBox = [m.startswith(Imp) for m in Mail.bodies]
		ml = 0
		if True in MBox:
			ml = MBox.index(True)
			break
	else:
		Oops("No known Message Order: %s" % Mail.bodies)
	
	Order, Body = Mail.bodies[ml].split(":")
	
	if not Own["IsTalking"] and not Own["IsCancel"] and Order == "Start":

		T,S = Body.split("|")
		
		if T.isdigit() or S.isdigit(): # Target & Seaker als ID oder Name
			Tar = [o for s in bge.logic.getSceneList() for o in s.objects if str(id(o))==T][0]
			Spk = [o for s in bge.logic.getSceneList() for o in s.objects if str(id(o))==S][0]
		else:
			Tar = SearchSceObj(T)
			Spk = SearchSceObj(S)
		
		# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ globale QnD Variablen
		if not hasattr(bge,"QnD_Global"):
			bge.QnD_Global = {}
			bge.QnD_Global["UsedProps"] = []
			#print(">> create QnD_Global")
		
		bge.QnD_Global["Player"] = Spk
		bge.QnD_Global["NPC"] = Tar
		bge.QnD_Global["Base"] = Own
			
		Own["CurrTar"] = Tar
		Own["CurrSpk"] = Spk
	
		if not hasattr(DB, Tar["QnD"]):
			Oops("Tree not in Database: %s : '%s'" % (Tar.name, Tar["QnD"]))

		else:
			# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ check Global Dict
			Tree = getattr(DB, Tar["QnD"])
			TarN = Tar.name
			SteN = "%s_State" % Tar["QnD"]
			
			if TarN not in QnDDic:
				QnDDic[TarN] = {SteN:0}
			else:	# Tree von außen geändert, füge State hinzu
				if not SteN in QnDDic[TarN]:
					QnDDic[TarN][SteN] = 0
		
			# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ suche Starte Node -> Flow Slot
			i = [n for n in Tree if n[0][0] == "QnD_Start"][0]
			Own["Next"] = i[1][0]
			
			Own["IsTalking"] = True
			RestartToNext()
	
	elif Order == "Next" and Own["IsTalking"] == True:	# ================= >> NEXT <<
		Tree = getattr(DB, Own["CurrTar"]["QnD"])
		TarN = Own["CurrTar"].name
		SteN = "%s_State" % Own["CurrTar"]["QnD"]
		
		#print(GloDic)
		
		if Own["Next"] < 0:
			Oops("Empty Output. Can't identify next Node.")
		else:
			Node = Tree[Own["Next"]]
			
			Re = Work(Node)
			if Re:					# Script beenden wenn False
				RestartToNext()
	
	elif Order == "Select":	# ============================================= >> SELECT <<
		Own["Next"] = Own["CurrDlnk"][int(Body)]
		RestartToNext()
	
	else: #Order == "Cancel":
		# ◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦◦ suche Starte Node -> Cancel Slot
		if Own["IsCancel"] == False and Own["CurrTar"]:
			Tree = getattr(DB, Own["CurrTar"]["QnD"])
			i = [n for n in Tree if n[0][0] == "QnD_Start"][0]
		
			nn = i[1][1]
			if nn != "*":
				Own["IsCancel"] = True
				Own["Next"] = nn
				RestartToNext()
			else:
				Work((("QnD_End",),-1)) # Fake End mit -1 Option